/*
Interactions

`Interactions are managed by our flow designer in UI, what you can control via api is how you start and run interaction flow for contact sending events.  Interaction can start in a multiple ways:  - EntryPont - when contact scans QR code ar opens entry point link  - event as trigger - this way you can start flow for single contact  ## Events Events are a data structure related to some contact action. You can use them whenever you want to start active interaction for contact but also inside interaction flow you can define points wher system should wait for custom event sent from your side.   Depending on your use case our predefined interactions might have defined events and instruction what events should be sent.  Events can be sent directly using our REST Api or triggered automatically by our integration modules.  ## Adding attributes to events Adding attributest to event can personalize communication, select branch flow based on attribute value or use them as perameters in other interaction flow actions. Use `body` property in event structure to add key-value attributes. 

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package interactions

import (
	"encoding/json"
)

// checks if the ActionConfig type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &ActionConfig{}

// ActionConfig struct for ActionConfig
type ActionConfig struct {
	Percentage int32 `json:"percentage"`
	// Required data is defined by and dependant on action
	Data map[string]interface{} `json:"data"`
}

// NewActionConfig instantiates a new ActionConfig object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewActionConfig(percentage int32, data map[string]interface{}) *ActionConfig {
	this := ActionConfig{}
	this.Percentage = percentage
	this.Data = data
	return &this
}

// NewActionConfigWithDefaults instantiates a new ActionConfig object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewActionConfigWithDefaults() *ActionConfig {
	this := ActionConfig{}
	return &this
}

// GetPercentage returns the Percentage field value
func (o *ActionConfig) GetPercentage() int32 {
	if o == nil {
		var ret int32
		return ret
	}

	return o.Percentage
}

// GetPercentageOk returns a tuple with the Percentage field value
// and a boolean to check if the value has been set.
func (o *ActionConfig) GetPercentageOk() (*int32, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Percentage, true
}

// SetPercentage sets field value
func (o *ActionConfig) SetPercentage(v int32) {
	o.Percentage = v
}

// GetData returns the Data field value
func (o *ActionConfig) GetData() map[string]interface{} {
	if o == nil {
		var ret map[string]interface{}
		return ret
	}

	return o.Data
}

// GetDataOk returns a tuple with the Data field value
// and a boolean to check if the value has been set.
func (o *ActionConfig) GetDataOk() (map[string]interface{}, bool) {
	if o == nil {
		return map[string]interface{}{}, false
	}
	return o.Data, true
}

// SetData sets field value
func (o *ActionConfig) SetData(v map[string]interface{}) {
	o.Data = v
}

func (o ActionConfig) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o ActionConfig) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	toSerialize["percentage"] = o.Percentage
	toSerialize["data"] = o.Data
	return toSerialize, nil
}

type NullableActionConfig struct {
	value *ActionConfig
	isSet bool
}

func (v NullableActionConfig) Get() *ActionConfig {
	return v.value
}

func (v *NullableActionConfig) Set(val *ActionConfig) {
	v.value = val
	v.isSet = true
}

func (v NullableActionConfig) IsSet() bool {
	return v.isSet
}

func (v *NullableActionConfig) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableActionConfig(val *ActionConfig) *NullableActionConfig {
	return &NullableActionConfig{value: val, isSet: true}
}

func (v NullableActionConfig) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableActionConfig) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


